from pygame.sprite import RenderUpdates
from pygame.image import load
import Graphics_Config
from Weapons import WList
import Weapons
import Sounds
import Prefs
from random import randint, choice
#from Graphics_Config import Blocks, Walls, Items
# ^^ This function now lives in the object land
import Objects, Items, Players
print "Loading Levels..."

class Level:
	std = True
	def __init__(self, file):
		data = open(file, 'r').readlines()
		self.data = data[1:]
		self.mineflag = False
		self.override_direction = True
		self.incarns = []
		self.scripts = []
		self.n = 0
		self.incarntimes = []
		(self.version, self.name, self.author, 
			self.picture, self.nplayers) = data[0].split('; ')
		self.nplayers = int(self.nplayers)
		if self.nplayers < 0: 
			self.std = False
			self.nplayers *= -1

	def doscripts(self):
		self.n += 1
		for script in self.scripts:
			if not script[1]: 
				script[1] = script[2]
				script[0](self)
			else:
				script[1] -= 1
	def load(self):
		"""Generates Layers."""
		self.background = load('Data/Levels/'+self.picture)#.convert()
		self.players = RenderUpdates()
		self.bounds = RenderUpdates()
		self.objects = RenderUpdates() # shots
		self.items = RenderUpdates() 
		self.blocks = RenderUpdates()
		self.effects = RenderUpdates()
		self.layer_itterator = [
			self.items,
			self.players,
			self.objects,
			self.blocks,
			self.effects
			]
		self.spawnpoints = []
		self.prnt = 'Welcome to '+self.name
		for line in self.data:
			if line == '\n' or line[0] == '#': continue
			line = line.split()
			if line[0] == 'block':
				self.blocks.add(Objects.Block(
					int(line[1]), int(line[2]),
					int(line[3]), self
					))
			elif line[0] == 'gblock':
				self.blocks.add(Objects.GBlock(
					int(line[1]), int(line[2]),
					(int(line[3]),int(line[4])), self
					))
			elif line[0] == 'tblock':
				t = int(line[3])
				if t < 0:
					t = randint(150,abs(t))
				self.blocks.add(Objects.TBlock(
					int(line[1]), int(line[2]),
					t, self
					))
			elif line[0] == 'switch':
				exec open('Data/Scripts/%s.py'%line[3])
				on = mscript
				if line[4] != '-':
					exec open('Data/Scripts/%s.py'%line[4])
					off = mscript
				else:
					off = None
				self.blocks.add(Objects.Switch(
					int(line[1]),int(line[2]),
					on, off, self
					))
			elif line[0] == 'set':
				print 'self.%s = %s'%(line[1],line[2])
				exec 'self.%s = %s'%(line[1],line[2])
			elif line[0] == 'barea':
				t = int(line[3])
				if t < 0:
					t = randint(150,abs(t))
				self.blocks.add(Objects.BArea(
					int(line[1]), int(line[2]),
					t, self
					))
			elif line[0] == 'wall':
				self.blocks.add(Objects.Wall(
					int(line[1]), int(line[2]),
					int(line[3]), self
					))
			elif line[0] == 'spawn':
				self.spawnpoints.append(
					(int(line[1]), int(line[2]))
					)
			elif line[0] == 'bound':
				self.bounds.add(
					Objects.Bound(
						int(line[1]), int(line[2]),
						int(line[3]), int(line[4])
					))
			elif line[0] == 'weap':
				self.objects.add(WList[int(line[3])](
					[int(line[4]),int(line[5])],
					[int(line[1]),int(line[2])],
					self, self
					))
			elif line[0] == 'item':
				s = int(line[3])
				if s == -101:
					item = Objects.GorgonItem
				elif s < 0:
					item = Objects.ShieldItem
				elif not s:
					item = Objects.SpeedItem
				elif s > 0:
					item = Objects.WeaponItem
				self.items.add(
					item(int(line[1]), int(line[2]),
						int(line[3]), self 
					))
			elif line[0] == 'tele':
				self.items.add(Objects.Teleporter(
					int(line[1]), int(line[2]),
					(int(line[3]), int(line[4])),
					self
					))
			elif line[0] == 'incarn':
				self.incarns.append((
					int(line[1]), int(line[2]),int(line[3]),
					int(line[4])
					))
				self.incarntimes.append(0)
			elif line[0] == 'ball':
				self.blocks.add(Objects.MobileBlock(
					int(line[1]), int(line[2]),
					0, self
					))
			elif line[0] == 'pill':
				self.players.add(Players.Pill(None, -1,
					(int(line[1]), int(line[2])),
					self, 'Pillbox'
					))
			elif line[0] == 'pepper':
				self.players.add(Players.Pepper(None, -1,
					(int(line[1]), int(line[2])),
					self, 'Bell Pepper'
					))
			elif line[0] == 'script':
				tmp = open('Data/Scripts/%s.py'%line[1]).read()
				exec tmp
				self.scripts.append( [mscript, int(line[2]), int(line[3])] )
			else:
				print "Unknown object `%s'." % line[0]
	def incarnate(self, n, name='Noone', type=0):
		# Incarnate a player
		player = Players.Player(
			Prefs.keys[n-1], n, self.spawnpoints[n-1],
			self, name, type=type
			)
		self.players.add(player)
		return player
					
				
				
