print "Loading Weapons..."
import pygame
from pygame.sprite import Sprite
from pygame.rect import Rect
import Sounds, Objects, Players
import Graphics_Config
from random import randint, choice
from copy import copy
from math import sin, cos
Global_Pillcount = 0


class Weapon(Sprite):
	# Basic parent class of the weapons.
	# Needs just four methods, collide,
	# mupdate, destroy and init.
	nhitme = False
	type = -1
	override_direction = False
	scount = -1
	def __init__(self, direction, position, Level, player):
		self.Level = Level
		self.player = player
		self.player.secondaryname = self.name
		self.speed = list(direction)
		self.image = self.images[0]
		if isinstance(self.image, list):
			self.image = self.images[0][0]
		self.rect = Rect(*tuple(position)+self.image.get_size())
		Sprite.__init__(self)
		self.n = 0
		self.dir = direction
		self.player.recycle2timer = 0
		if self.sound: self.channel = self.sound.play()
		self.init(direction, position)
	def collide(self, player):
		pass # Attack player __or_block__!.
	def update(self):
		self.rect.move_ip(self.speed)
		# Add animation features here.
		self.mupdate()
		if self.life and self.n > self.life:
			self.destroy(type=self.n*-1)
		if self.rect.x > 1024 or self.rect.x < 0 or self.rect.y > 768 or self.rect.y < 0:
			self.destroy(); self.kill()
		self.n += 1
	def init(self, direction, position):
		pass # Init should set speed, etc.
	def mupdate(self):
		pass
	def destroy(self, type=0):
		self.kill() # Destroy prettily.


class Plasma(Weapon):
	images = Graphics_Config.PlasmaShot
	life = 30
	type = 0
	name = 'Plasma'
	recycle = 20 # Not used but has to exist.
	sound = Sounds.Plasma
	def collide(self, player):
		if self.player == player: return
		player.shield -= self.player.plasmapower
		player.lastdamage = '%s\'s plasma'%self.player.name
		player.lasthitter = self
		self.destroy()
	def destroy(self, type=0):
		if type < 0: self.kill(); return
		self.Level.effects.add(Objects.Explosion(
			(self.rect.x-16, self.rect.y-16),
			Graphics_Config.PlasmaExplosion,
			self.Level
			))
		Sounds.Explosion.play()
		self.kill()
	def init(self, direction, position):
		self.speed = [direction[0]+(8*cmp(direction[0], 0)),
			direction[1]+(8*cmp(direction[1], 0))
			]



class PillShot(Weapon):
	images = Graphics_Config.PillShot
	life = 18
	scount = 8
	frame = 0
	dist =0 
	type = 0
	i = 0
	name = 'Nanite Swarm'
	recycle = 4
	sound = Sounds.PillShot
	def collide(self, player):
		if self.player is player: return
		if player.shield >= 0: 
			player.shield  -= 10
			self.dist += 1
		player.lastdamage = '%s\'s nanites'%self.player.name
		player.lasthitter = self

	def destroy(self, type=0):
		if type > 0: 
			self.n = 1
			return
		else:
			self.kill()

	def init(self, direction, position):
		self.direction = direction
		self.dist = 40
	def mupdate(self):
		self.i += 0.2
		self.image = self.images[self.frame]
		self.frame += 1
		if self.frame > 2: 
			self.frame = 0
			
		if self.player.shield > 0:
			self.rect.x = int( cos(self.i)*self.dist + self.player.rect.x )
			self.rect.y = int( sin(self.i)*self.dist + self.player.rect.y )
		#[randint(-1,1),randint(-1,1)]




class BlastZone(Weapon):
	images = [Graphics_Config.NilImg]
	life = 2
	type = -2
	name = 'Blast'
	recycle = 0
	sound = None
	def init(self, power, position): # Note that the direction is ignored, used for blast power.
		self.speed = [0,0]
		self.power = power[0] # Power should be (blastpower, (width,height))
		self.rect = Rect(*tuple(position)+power[1])
	def collide(self, player):
		player.shield -= self.power
		try:
			player.lastdamage = 'the blast of %s\'s %s'%(self.player.player.name, self.player.name)
		except:
			player.lastdamage = 'an aetheral energy force'
		player.lasthitter = self.player
	def destroy(self, type=0):
		if type < 0:
			self.kill()

		
class GorgonBlastZone(BlastZone):
	def collide(self, player):
		if self.player.am == 0:
			player.shield -= self.power
			player.lastdamage = 'an aetheral energy force'
			player.lasthitter = self.player
		elif self.player.am == 1 and (not isinstance(player, Objects.Block) or isinstance(player, Objects.MobileBlock)):
			player.rect = copy(self.player.rect)
			self.Level.prnt = "%s was caught in an aetheral energy eddy!"%player.name
		elif self.player.am == 2:
			player.speed = [randint(-20,20),randint(-20,20)]
			self.Level.prnt = "%s was struck by an aetherial energy force!"%player.name
		elif self.player.am == 4:
			self.Level.objects.add(PillShot(
				[0,0], 
				[self.rect.x,self.rect.y],  
				self.Level, self.player
				))

				
		elif self.player.am == 3:
			if isinstance(player, Players.Player) and player.type != 4:
				player.malfunction = [100,player.type]
				player.type = 4
				self.Level.prnt = "Aetherial energies are controlling %s!"%player.name
			elif isinstance(player, Drone):
				player.secondary = choice(WList)
				player.fuel = randint(0,1000)
				player.shield = randint(0,2000)
				self.Level.prnt = "Aetherial energies mutate %s!"%player.name
			elif isinstance(player, Objects.MobileBlock) and player.speed != [0,0]:
				self.Level.prnt = "Woah. That's something you don't see every day."
				player.kill()
				self.Level.players.add(Players.Player(
					None, self.player.id, (player.rect.x+4, player.rect.y+4), self.Level,
					"%s's Block Golem"%self.player.name, type=2
					))
				self.Level.effects.add(Objects.Explosion(
					[player.rect.x-16, player.rect.y-16],
					Graphics_Config.PortFlash, self.Level
					))
			elif isinstance(player, Objects.Block):
				player.kill()
				self.kill()
				item,k = choice([(Objects.Wall,0), (Objects.Block,0), (Objects.MobileBlock,0), 
					(Objects.GBlock,randint(0,2)), (Objects.TBlock,randint(0,200)), (Objects.BArea, randint(0,200))
					])
				if item == Objects.TBlock or item == Objects.BArea:
					self.Level.blocks.add(item(
						player.rect.x, player.rect.y,
						k, self.Level
						))
				else:
					self.Level.blocks.add(item(
						player.rect.x, player.rect.y,
						(k,0), self.Level
						))
				self.Level.effects.add(Objects.Explosion(
					[player.rect.x-8, player.rect.y-8],
					Graphics_Config.PortFlash, self.Level
					))
				self.Level.prnt = "Aetherial energies transmute a %s!"%player.name

class DetectorZone(Weapon):
	images = [Graphics_Config.NilImg]
	name = 'Detection Field'
	recycle = 0
	type = -2
	nhitme = True
	life = 0
	sound = None
	def init(self, size, position):
		self.speed = [0,0]
		self.rect = Rect(*tuple(position)+tuple(size))
		self.player.zonedetectors.append(self)
	def collide(self, player):
		if not isinstance(player, Objects.Block)  and player != self.player.player:
			self.player.zonedetection = player
	def destroy(self, type=0):
		pass
			
class Flak(Weapon):
	images = Graphics_Config.Flak
	life = 12
	type = 3
	name = 'Flack'
	recycle = 0
	sound = None#Sounds.Flak # Get sound
	ps = True
	def collide(self, player):
		if self.player == player: return
		player.shield -= 4
		player.lastdamage = '%s\'s flack'%self.player.name
		self.destroy()
		player.lasthitter = self
	def destroy(self, type=0):
		if type > 0: return
		if self.channel: 
			self.channel.stop()
			self.player._FlakSound -= 1
		self.kill()
	def init(self, direction, position):
		self.channel = None
		try:
			self.player._FlakSound
		except:
			self.player._FlakSound = 0

		if not self.player._FlakSound and self.ps:
			self.channel = Sounds.Flak.play()
		if self.channel:
			self.player._FlakSound += 1
		self.rect.move_ip((6,12))
		self.speed = [
			direction[0]+randint(5,10)*cmp(direction[0],0),
			direction[1]+randint(5,10)*cmp(direction[1],0)
			]
	def mupdate(self):
		self.speed[0] += randint(-1,1)
		self.speed[1] += randint(-1,1)

class SubPolaron(Flak):
	type = 4
	images = Graphics_Config.SubPolaron
	ps = False
	
class Rocket(Weapon):
	images = Graphics_Config.Rocket
	life = 90
	name = 'Explosive Rocket'
	recycle = 25
	type = 1
	scount = 20
	sound = Sounds.Rocket
	def collide(self, player):
		if self.player == player: return
		player.shield -= 30
		player.lastdamage = '%s\'s rocket'%self.player.name
		self.destroy()
		player.lasthitter = self
	def destroy(self, type=0):
		if type < 0: self.kill(); return
		self.Level.effects.add(Objects.Explosion(
			(self.rect.x-16, self.rect.y-16), # may need fixing
			Graphics_Config.Explosion,
			self.Level
			))

		self.Level.objects.add(BlastZone(
			(20, (40,40)), [self.rect.x-12, self.rect.y-12],
			self.Level, self
			))
			
		Sounds.RocketExplode.play()
		i = 0
		m = randint(7,17)
		while i < m:
			self.Level.effects.add(Objects.Shrapnel(
				[self.rect.x,self.rect.y], 
				[randint(-1,2)*self.speed[0], randint(-1,2)*self.speed[1]], 
				Graphics_Config.Shrapnel_Grey, self.Level
				))
			i += 1
		self.kill()
	def init(self, direction, position):
		self.speed = [direction[0]+(12*cmp(direction[0], 0)),
			direction[1]+(12*cmp(direction[1], 0))
			]
		self.image = self.images[1+cmp(direction[0],0)][1+cmp(direction[1],0)]
		




class Mine(Weapon):
	images = Graphics_Config.Mine
	life = 0
	name = 'Explosive Mine'
	recycle = 15 
	type = 2
	noblast = False
	override_direction = True
	scount = 12
	bitcap = 0
	exploded = False
	bits = Flak
	sound = Sounds.MineLay
	def collide(self, player):
		if self.player == player or isinstance(player, Mine): return
		player.shield -= 110
		player.lastdamage = '%s\'s mine'%self.player.name
		self.destroy()
		self.speed = [cmp(self.rect.x, player.rect.x)*10,cmp(self.rect.y,player.rect.y)]
		player.lasthitter = self
	def destroy(self, type=0):
		if self.exploded: return
		self.exploded = True
		self.Level.effects.add(Objects.Explosion(  
			(self.rect.x-16, self.rect.y-16),
			Graphics_Config.Explosion, # need explode
			self.Level
			))

		if not self.noblast: self.Level.objects.add(BlastZone(
			(32, (96,96)), [self.rect.x-32, self.rect.y-32],
			self.Level, self
			))
			
		Sounds.MExplode.play()
		if self.Level.mineflag < 4:
			i = 0
			m = randint(3,9)
			while i < m:
				self.Level.effects.add(Objects.Shrapnel(
					[self.rect.x,self.rect.y],  
					[randint(-12,12), randint(-12,12)], 
					Graphics_Config.Shrapnel_Grey, self.Level
					))
				i += 1
		if type >= 0: # no flack from random detonations.
			i = 0
			if self.bitcap:
				m = self.bitcap
			else:
				m = max(2,15-self.Level.mineflag)
			while i < m:
				self.Level.objects.add(self.bits(
					[randint(-12,12), randint(-12,12)], 
					[self.rect.x+randint(-10,10),
						randint(-10,10)+self.rect.y], 
					self.Level, self
					))
				i += 1
		self.Level.mineflag += 2
		self.kill()
	def init(self, direction, position):
		if self.player.override_direction:
			self.speed = direction
		else:
			self.speed = [0,0]
	def mupdate(self):	
		if self.n > 600 and not randint(0, max(9000-self.n,500) ):
			self.destroy(type=-1) #Muahhaha
			self.Level.prnt="%s's mine malfunctioned and spontaneously exploded!"%self.player.name

#class SMine(Mine):
#	sound = None
#	images = Graphics_Config.Gorgon

class Blocker(Mine):
	name = 'Block Layer'
	scount = 10
	recycle = 20
	def init(self, direction, position):
		self.kill()
		self.Level.blocks.add(Objects.BArea(
			position[0]-4, position[1]-4,
			100, self.Level
			))
		self.Level.bounds.add(Objects.Bound(
			position[0]-4, position[1]-4,
			position[0]+28,position[1]+28,
			))
	def update(self):
		self.kill()





class Drone(Weapon):
	images = Graphics_Config.Drone
	life = 1000
	recycle = 20
	scount = 2
	converted = False
	type = 5
	collided_block = False
	bouncey = True
	enginetimer = 0
	engine = True
	dead = False
	maxspeed = 5
	recycle1timer = 0
	shield = 30
	secondary = Plasma
	recycle2 = 5
	recycle2timer = 0
	lastdamage = 'collision with an obstruction'
	plasmapower = 10
	firen = 0
	directs = [[5,0],[0,5],[-5,0],[0,-5],[5,0]]
	dn = 0
	name = 'Drone'
	sound = Sounds.Drone
	def collide(self, player):
		if player == self.player: 
			return
		elif player:
			self.destroy()
		Sounds.Hit.play()
		#self.dn += 1
		#self.speed = self.directs[self.dn]
		#self.rect.move_ip([self.speed[0],self.speed[1]])
		if self.dn == 4: self.dn = 0
		if player: player.lasthitter = self
	def mupdate(self):
		if self.n > 7 and not self.converted:
					self.Level.players.add(self)
					self.Level.objects.remove(self)
					self.converted = True

		if self.n > 20 and not self.recycle2timer:
			self.Level.objects.add(self.secondary(
				self.directs[self.dn+1], [self.rect.x+self.directs[self.dn+1][0],self.rect.y+self.directs[self.dn+1][1]],
				self.Level, self
				))
			self.recycle2timer = self.recycle2*2
			self.firen = self.n
		if self.shield < 0: self.destroy()
		if self.collided_block:
			self.collided_block = False
			self.collide(None)
		if self.recycle2timer: self.recycle2timer -= 1
		if not randint(0,300):
			self.speed = choice(self.directs)
		if self.rect.x > 1000 or self.rect.x < 20 or self.rect.y > 750 or self.rect.y < 20:
			self.collide(None)
		if not self.enginetimer and self.n > 100:
			self.speed = self.directs[self.dn]
		else:
			self.enginetimer -= 1
	def destroy(self, type=0):
		if type < 0: self.lastdamage = 'running out of fuel and crashing'; self.shield = -10
		self.Level.effects.add(Objects.Explosion(
			(self.rect.x-16, self.rect.y-16),
			Graphics_Config.PlayerExplode,
			self.Level
			))
		Sounds.Explosion.play()
		i = 0
		m = randint(3,9)
		while i < m:
			self.Level.effects.add(Objects.Shrapnel(
				[self.rect.x,self.rect.y], 
				[randint(-12,12), randint(-12,12)], 
				Graphics_Config.Shrapnel_Grey, self.Level
				))
			i += 1
		self.Level.prnt = "%s was destroyed by %s."%(self.name, self.lastdamage)
		self.kill()
		self.dead = True
		
	def init(self, direction, position):
		self.name = '%s\'s Drone'%self.player.name
		self.image = self.images[self.player.id-1]
		self.speed = [5*cmp(direction[0], 0),
			5*cmp(direction[1], 0)
			]
		self.id = self.player.id

class Polaron(Weapon):
	images = Graphics_Config.Polaron
	life = 80
	name = 'Polaronic Burst'
	recycle = 50
	type = 4
	cols = 0
	lastcol = 0
	sound = Sounds.Polaron
	def collide(self, player):
		if self.player == player or self.lastcol + 5 > self.n: return
		player.shield -= 550-5*self.cols
		player.lastdamage = '%s\'s polaron bursts'%self.player.name
		self.cols += 1
		self.destroy()
		self.lastcol =self.n
		if self.cols > 10: self.destroy(-1)
		self.speed = [self.speed[0]+randint(-1,1),self.speed[1]+randint(-1,1)]
		player.lasthitter = self
	def destroy(self, type=0):
		if type < 0: self.kill(); return
		if type > 0: return
		self.Level.effects.add(Objects.Explosion(
			(self.rect.x-16, self.rect.y-16),
			Graphics_Config.PolaronExplode,
			self.Level
			))
		i = 0
		while i < 5:
			self.Level.objects.add(SubPolaron(
				self.calcs(), 
				[self.rect.x,self.rect.y], 
				self.Level, self
				))
			i += 1
		Sounds.Explosion.play()
	def init(self, direction, position):
		self.player.recycle = 50
		if not self.player.override_direction:
			self.speed = [direction[0]+(1*cmp(direction[0], 0)),
				direction[1]+(1*cmp(direction[1], 0))
				]
			self.player.engine = False
			self.player.enginetimer += 45
			self.player.recycle1timer += 245
		else:
			self.speed = [direction[0],direction[1]]
		
	def mupdate(self):
		if not self.n%5:
			self.speed[0] += self.dir[0]
			self.speed[1] += self.dir[1]
	def calcs(self):
		if self.speed[0] > self.speed[1]:
			return [self.speed[0]+randint(-2,2), randint(-10,10)]
		else:
			return [randint(-10,10),self.speed[1]+randint(-2,2)]

class Seeker(Weapon):
	images = Graphics_Config.Seeker
	life = 0
	fuel = 100
	channel = None
	scount = 6
	target = None
	type = 6
	name = 'Automatic Seeker'
	recycle = 50
	sound = Sounds.MineLay
	def collide(self, player):
		if self.player == player and not self.target: return
		if isinstance(player, Objects.Block):
			self.speed = [self.speed[0]*-1,self.speed[1]*-1]
			self.rect.move_ip(self.speed)
		else:
			player.shield -= 195
			player.lastdamage = '%s\'s autoseeker'%self.player.name
			self.destroy()
		player.lasthitter = self
	def destroy(self, type=0):
		if type < 0:
			self.Level.prnt = "%s ran out of fuel and crashed."%self.name
		self.Level.effects.add(Objects.Explosion(  
			(self.rect.x-16, self.rect.y-16),
			Graphics_Config.Explosion, # need explode
			self.Level
			))

		Sounds.MExplode.play()
		if self.Level.mineflag < 4:
			i = 0
			m = randint(3,9)
			while i < m:
				self.Level.effects.add(Objects.Shrapnel(
					[self.rect.x,self.rect.y], 
					[randint(-12,12), randint(-12,12)], 
					Graphics_Config.Shrapnel_Grey, self.Level
					))
				i += 1
		self.Level.mineflag += 2
		self.kill()
		if self.channel: self.channel.stop()
		self.zonedetectors[0].kill()
	def init(self, direction, position):
		self.image = self.images[self.player.id-1][0]
		self.name = '%s\'s automatic seeker'%self.player.name
		self.speed = [0,0]
		self.zonedetection = None
		self.zonedetectors = []
		self.Level.objects.add(DetectorZone(
			[160,160], [self.rect.x-60,self.rect.y-60],
			self.Level, self
			))
			
	def mupdate(self):	
		if self.zonedetection:
			self.zonedetectors[0].kill()
			self.Level.prnt = "%s locked in on %s and armed!"%(self.name,self.zonedetection.name)
			self.image = self.images[self.player.id-1][1]
			self.target = self.zonedetection
			self.zonedetection = None
			self.fuel = 225
			self.channel = Sounds.Alarm.play(10)
		elif self.target:
			try:
				self.fuel -= 1
			except:
				self.destroy()
			if not self.fuel: 
				self.Level.prnt = "%s ran out of fuel and crashed."%self.name
				self.destroy(-1)
			if self.rect.x > self.target.rect.x and self.speed[0] > -10:
				self.speed[0] -= 1
			elif self.rect.x < self.target.rect.x and self.speed[0] < 10:
				self.speed[0] += 1
			if self.rect.y > self.target.rect.y and self.speed[1] > -10:
				self.speed[1] -= 1
			elif self.rect.y < self.target.rect.y and self.speed[1] < 10:
				self.speed[1] += 1
				
			if self.target.shield <= 0:
				self.target = choice(self.Level.players.sprites())
				self.Level.prnt = "%s lost it's target and is going after %s instead!"%(
					self.name,self.target.name)

class Shield(Weapon):
	images = Graphics_Config.Shield
	life = 300	
	name = 'Force Shield'
	scount = 1
	type = 7
	recycle = 200
	sound = None#Sounds.Flak # Get sound
	ps = True
	def collide(self, player):
		if self.player == player: return
		player.shield -= 14
		try:
			player.speed = [player.speed.x*-1,player.speed.y*-1]
		except:
			pass
		player.lastdamage = '%s\'s force shield'%self.player.name
		self.destroy()
		player.lasthitter = self
	def destroy(self, type=0):
		self.player.shield = 10
		if type < 0: 
			self.kill()
			if self.channel: 
				self.channel.stop()
				self.player._LaseSound -= 1
	def init(self, direction, position):
		self.channel = None
		try:
			self.player._LaseSound
		except:
			self.player._LaseSound = 0

		if not self.player._LaseSound and self.ps:
			self.channel = Sounds.Shield.play()
		if self.channel:
			self.player._LaseSound += 1
		self.rect.move_ip((-12,-12))
		self.speed = self.player.speed
	def mupdate(self):		
		if self.player.dead:
			try:
				self.target = choice(self.Level.players.sprites())
			except:
				self.kill()
			self.mupdate = self.deathseeker
			self.Level.prnt = "%s's %s has gone wild! It's after %s!"%(self.player.name, self.name, self.target.name)
			self.n = 600
			self.name += ' (wild)'
		else:
			self.rect.x = self.player.rect.x-12
			self.rect.y = self.player.rect.y-12
		if self.n == 290: Sounds.ShieldLow.play()
	def deathseeker(self):
		self.rect.x += cmp(self.target.rect.x, self.rect.x)*5
		self.rect.y += cmp(self.target.rect.y, self.rect.y)*5
		if self.target.dead:
			try:
				self.target = choice(self.Level.players.sprites())
				self.Level.prnt = 'Run, %s, run!'%self.target.name
			except:
				self.kill()


class Floatie(Shield):
	life = 0
	scount = 1
	plasmapower = 5
	name = 'Reflector Shield'
	converted = False
	images = Graphics_Config.Floatie
	def init(self, direction, position):
		if self.player.bouncey:
			self.kill()
		self.player.recycle1timer = 10000000
		self.player.recycle2timer = 10000000
	def mupdate(self):
		if not self.converted:
			self.Level.objects.remove(self)
			self.Level.effects.add(self)
			self.player.bouncey = True
			self.converted = True
		if self.player.dead:
			self.kill()
		self.rect.x, self.rect.y = self.player.rect.x-12, self.player.rect.y-12
		for hit in pygame.sprite.spritecollide(self, self.Level.objects, 0):
			hit.speed = [hit.speed[0]*-1, hit.speed[1]*-1]
			if isinstance(hit, Flak): 	
				hit.destroy(type=-1)
				continue
			elif isinstance(hit, Rocket):
				hit.image = hit.images[1+cmp(hit.speed[0],0)][1+cmp(hit.speed[1],0)]
			elif isinstance(hit, DetectorZone) or isinstance(hit, BlastZone):
				continue
			elif isinstance(hit, Seeker) or isinstance(hit, Nanoids):
				self.Level.prnt = '%s malfunctions and pursues %s!'%(hit.name, hit.player.name)
				hit.target = hit.player
				hit.player = self.player
			elif isinstance(hit, Goobers):
				hit.speed = Players.AimAt(self, hit.player)

			elif isinstance(hit, Shield):
				self.kill()
				hit.kill()
				self.player.speed, hit.player.speed = copy(hit.player.speed), copy(self.player.speed)
				self.player.bouncey = False
				self.Level.prnt = 'Shields neutralize one another!'
		

			self.player.shield -= 2
			self.player.lastdamage = 'Refector Shield Feedback'
			self.player.lasthitter = hit
			hit.player = self.player
			hit.name += ' (Reflected)'
			
class SubPolaronMine(Mine):
	bitcap = 25
	bits = SubPolaron

class SMine(SubPolaronMine):
	sound = None
	images = Graphics_Config.Gorgon


class PolaronMine(Mine):
	name = "Baleful Mine of Doom"
	bitcap = 6
	images = Graphics_Config.PMine
	scount = 2
	recycle = 50
	bits = Polaron
	
class PlasmaMine(Mine):
	noblast = True
	bitcap = 12
	plasmapower = 20
	bits = Plasma	
class SeekerMine(Mine):
	noblast = True
	shield = 10
	name = "Seeker Drop Mine"
	bitcap = 1
	id = 4
	bits = Seeker
class RocketMine(Mine):
	noblast = True
	name = "Rocket Mine"
	bitcap = 1
	id = 4
	bits = Rocket
class DroneMine(Mine):
	noblast = True
	name = "Drone Mine"
	bitcap = 1
	id = 4
	bits = Drone
Mines = [ SubPolaronMine, PolaronMine,PlasmaMine, SeekerMine,RocketMine,DroneMine,Mine]

class Nanoids(Weapon):
	images = Graphics_Config.PillShot
	life = 50
	scount = 16
	frame = 0
	dist =0 
	type = 0
	i = 0
	name = 'Nanite Spread'
	recycle = 6
	sound = Sounds.SeekerNan
	def destroy(self, type=0):
		if type: 
			return
		else:
			self.kill()

	def collide(self, player):
		if self.player is player: 
			if self.n > 10: 
				self.player.scount += 1
			else:
				return
		player.shield  -= 1
		if player.shield < 0: 
			self.destroy()
			self.target = self.player
		self.speed = [randint(-4,4),randint(-4,4)]
		player.lastdamage = '%s\'s nanite spread'%self.player.name
		player.lasthitter = self


	def init(self, direction, position):
		self.direction = direction
		self.position = position
		md = 3000
		self.target = None
		for thing in self.Level.players.sprites():
			if thing is self.player: continue
			td = Players.Dist(self, thing)
			if td < md:
				md = td
				self.target = thing
		if not self.target:
			self.destroy(0)
		self.dist = 40
	def mupdate(self):
		if self.n > self.life: self.destroy(0)
		self.image = self.images[self.frame]
		self.frame += 1
		if self.frame > 2: 
			self.frame = 0
			if self.target and self.target.shield > 0:
				self.speed = Players.AimAt(self,self.target)
			
class Goobers(Weapon):
	images = Graphics_Config.Goober
	life = 330
	frame = 0
	dist =0 
	type = 0
	i = 0
	name = 'Gluon Goober'
	recycle = 16
	sound = Sounds.Goober
	def destroy(self, type=0):
		if not type: 
			self.kill()
			self.Level.effects.add(Objects.Explosion(
				(self.rect.x-16, self.rect.y-16),
				Graphics_Config.PortFlash,
				self.Level
				))


	def collide(self, player):
		if player is self.player: return
		if player.__class__ in Objects.Solids:
			self.speed = [randint(-5,5),randint(-5,5)]
			self.life -= 100
		else:
			player.shield  -= 8
			self.destroy()
			player.lastdamage = '%s\'s Goobers'%self.player.name
			player.lasthitter = self


	def init(self, direction, position):
		self.direction = direction
		self.position = position
		md = 3000
		self.target = None
		for thing in self.Level.players.sprites():
			if thing is self.player: continue
			td = Players.Dist(self, thing)
			if td < md:
				md = td
				self.target = thing
		if self.target:
			ts = Players.AimAt(self,self.target)
			self.speed = [ts[0]+randint(-1,1),ts[1]+randint(-1,1)]
		else:
			self.speed = [direction[0]*4,direction[1]*4]
	def mupdate(self):
		if self.n > self.life: self.destroy(0)
		self.image = self.images[self.frame]
		self.frame += 1
		if self.frame > 2: 
			self.frame = 0


WList = [Plasma, 
	Rocket,
	Mine,
	Flak,
	Polaron,
	Drone,
	Seeker,
	Shield,
	Blocker,
	Floatie,
	PillShot,
	PolaronMine,
	Nanoids,
	Goobers
	]
